<?php
// Author: Phil Ploquin, Tim Hockin
// Copyright 2000, Cobalt Networks.  All rights reserved.
// This is the Active Monitor settings config page

include("ArrayPacker.php");
include("ServerScriptHelper.php");

$servhelp = new ServerScriptHelper();
$cce = $servhelp->getCceClient();
$factory = $servhelp->getHtmlComponentFactory("base-am", 
	"/base/am/amSettingsHandler.php");
$page = $factory->getPage();
$i18n = $factory->i18n;
$errors = $servhelp->getErrors();

print($page->toHeaderHtml());

$amobj = $cce->getObject("ActiveMonitor");
if ($amobj == null)
{
	$msg = $factory->getTextBlock("", 
		$i18n->interpolate("[[base-am.amObjNotFound]]"), "r");
	print($msg->toHtml());
} else {
	$pagedBlock = $factory->getPagedBlock("amSettings");

	$pagedBlock->processErrors($errors, array( "enabled" => "enableAMField"));
	
	// enabled checkbox
	$pagedBlock->addFormField(
		$factory->getBoolean("enableAMField", $amobj["enabled"]),
		$factory->getLabel("enableAMField"));
	
	// alert list
	$alerts = $factory->getEmailAddressList("alertEmailList", 
		$amobj["alertEmailList"]);
	$alerts->setOptional(true);

	$pagedBlock->addFormField(
		$alerts,
		$factory->getLabel("alertEmailList"));

	$selected = array();
	$selectedVals = array();
	$notSelected = array();
	$notSelectedVals = array();

	$names = $cce->names($amobj["OID"]);
	$namespaces = array();

	for ($i=0; $i < count($names); ++$i) {
		$nspace = $cce->get($amobj["OID"], $names[$i]);
		$name = $i18n->get($nspace["nameTag"]);
		$namespaces[$name] = $nspace;
	}

	// sort by i18n'ed strings
	ksort($namespaces);
	
	while (list($name, $nspace) = each($namespaces)) {
		if (!$nspace["hideUI"]) {
			if ($nspace["monitor"]) {
				$selected[] = $name;
				$selectedVals[] = $nspace["NAMESPACE"];
			} else {
				$notSelected[] = $name;
				$notSelectedVals[] = $nspace["NAMESPACE"];
			}
		}
	}
	// $selected, $unselected = UI strings, already interpolated
	// selectedvals, unselectedvals = namespace tags
	$picklist = $factory->getSetSelector("itemsToMonitor",
		arrayToString($selected), arrayToString($notSelected), 
		"selected", "notSelected","rw",arrayToString($selectedVals),
		arrayToString($notSelectedVals));
	$picklist->setOptional(true);

	$pagedBlock->addFormField($picklist, 
		$factory->getLabel("itemsToMonitor"));

	$pagedBlock->addButton($factory->getSaveButton(
		$page->getSubmitAction()));
	print($pagedBlock->toHtml());
}

print($page->toFooterHtml());

$servhelp->destructor();

?>
