<?

// Author: James Cheng
// Copyright 2000, Sun Microsystems, Inc.  All rights reserved.

include("ServerScriptHelper.php");
include("base/am/am_detail.inc");

$serverScriptHelper = new ServerScriptHelper();
$cce = $serverScriptHelper->getCceClient();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-am");
$page = $factory->getPage();
$i18n = $serverScriptHelper->getI18n();

print($page->toHeaderHtml());

am_detail_block($factory, $cce, "Temp", "[[base-am.amTempDetails]]");

$subblock = $factory->getPagedBlock("amTempStats");


$tempinfo = fopen("/proc/cobalt/sensors/thermal", "r");
if ($tempinfo) {
  while (!feof($tempinfo)) {
    $line = fgets($tempinfo, 1024);
    list ($sensorNum, $sensorName, $temperature) = split ("([[:space:]]|\.|:|\[|\])+", $line);
    if ($sensorNum === false || !$temperature) {
      //need to do this check because there's an extra newline at end of file
      continue;
    }

    $subblock->addFormField(
			    $factory->getTextField("temp$sensorNum", 
						   $i18n->interpolate("[[base-am.amTemp]]", array( "temp" => $temperature)), "r"),
	  $factory->getLabel($i18n->interpolate("sensorName$sensorName")));
  }
} else {
  $subblock->addFormField($factory->getTextField('cant_get_info', $i18n->get('[[base-am.cant_get_tempinfo]]'), 'r'),
			  $factory->getLabel('amClientStatus'));
}
print("<BR>\n");
print($subblock->toHtml());

am_back($factory);
print ($page->toFooterHtml());


$serverScriptHelper->destructor();

?>
